diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/callback.h ns-3.31/src/core/model/callback.h
--- ns-3.30.1/src/core/model/callback.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/callback.h	2020-06-27 17:38:30.000000000 -0700
@@ -1075,23 +1164,25 @@
    * \param [in] other Callback Ptr
    * \return \c true if we have the same functor and bound arguments
    */
-  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const {
-    ThreeBoundFunctorCallbackImpl<T,R,TX1,TX2,TX3,T1,T2,T3,T4,T5,T6> const *otherDerived = 
+  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const
+  {
+    ThreeBoundFunctorCallbackImpl<T,R,TX1,TX2,TX3,T1,T2,T3,T4,T5,T6> const *otherDerived =
       dynamic_cast<ThreeBoundFunctorCallbackImpl<T,R,TX1,TX2,TX3,T1,T2,T3,T4,T5,T6> const *> (PeekPointer (other));
     if (otherDerived == 0)
       {
         return false;
       }
-    else if (otherDerived->m_functor != m_functor ||
-             otherDerived->m_a1 != m_a1 || otherDerived->m_a2 != m_a2 || otherDerived->m_a3 != m_a3)
+    else if (otherDerived->m_functor != m_functor
+             || otherDerived->m_a1 != m_a1 || otherDerived->m_a2 != m_a2 || otherDerived->m_a3 != m_a3)
       {
         return false;
       }
     return true;
   }
+
 private:
-  T m_functor;                                    //!< The functor      
-  typename TypeTraits<TX1>::ReferencedType m_a1;  //!< first bound argument 
+  T m_functor;                                    //!< The functor
+  typename TypeTraits<TX1>::ReferencedType m_a1;  //!< first bound argument
   typename TypeTraits<TX2>::ReferencedType m_a2;  //!< second bound argument
   typename TypeTraits<TX3>::ReferencedType m_a3;  //!< third bound argument
 };
@@ -1101,17 +1192,24 @@
  * Base class for Callback class.
  * Provides pimpl abstraction.
  */
-class CallbackBase {
+class CallbackBase
+{
 public:
-  CallbackBase () : m_impl () {}
+  CallbackBase () : m_impl ()
+  {}
   /** \return The impl pointer */
-  Ptr<CallbackImplBase> GetImpl (void) const { return m_impl; }
+  Ptr<CallbackImplBase> GetImpl (void) const
+  {
+    return m_impl;
+  }
+
 protected:
   /**
    * Construct from a pimpl
    * \param [in] impl The CallbackImplBase Ptr
    */
-  CallbackBase (Ptr<CallbackImplBase> impl) : m_impl (impl) {}
+  CallbackBase (Ptr<CallbackImplBase> impl) : m_impl (impl)
+  {}
   Ptr<CallbackImplBase> m_impl;         //!< the pimpl
 };
 
@@ -1133,22 +1231,22 @@
  * user intervention which allows you to pass around Callback
  * instances by value.
  *
- * Sample code which shows how to use this class template 
+ * Sample code which shows how to use this class template
  * as well as the function templates \ref MakeCallback :
  * \include src/core/examples/main-callback.cc
  *
  * \internal
- * This code was originally written based on the techniques 
+ * This code was originally written based on the techniques
  * described in http://www.codeproject.com/cpp/TTLFunction.asp
  * It was subsequently rewritten to follow the architecture
- * outlined in "Modern C++ Design" by Andrei Alexandrescu in 
+ * outlined in "Modern C++ Design" by Andrei Alexandrescu in
  * chapter 5, "Generalized Functors".
  *
  * This code uses:
  *   - default template parameters to saves users from having to
  *     specify empty parameters when the number of parameters
  *     is smaller than the maximum supported number
- *   - the pimpl idiom: the Callback class is passed around by 
+ *   - the pimpl idiom: the Callback class is passed around by
  *     value and delegates the crux of the work to its pimpl
  *     pointer.
  *   - two pimpl implementations which derive from CallbackImpl
@@ -1158,7 +1256,7 @@
  *   - a reference list implementation to implement the Callback's
  *     value semantics.
  *
- * This code most notably departs from the alexandrescu 
+ * This code most notably departs from the alexandrescu
  * implementation in that it does not use type lists to specify
  * and pass around the types of the callback arguments.
  * Of course, it also does not use copy-destruction semantics
@@ -1166,16 +1264,22 @@
  * the pointer.
  *
  * \see attribute_Callback
+ *
+ * \tparam R \explicit The return type of the Callback.
+ * The remaining template arguments are the types of any arguments
+ * to the Callback.
  */
-template<typename R, 
-         typename T1 = empty, typename T2 = empty, 
+template<typename R,
+         typename T1 = empty, typename T2 = empty,
          typename T3 = empty, typename T4 = empty,
          typename T5 = empty, typename T6 = empty,
          typename T7 = empty, typename T8 = empty,
          typename T9 = empty>
-class Callback : public CallbackBase {
+class Callback : public CallbackBase
+{
 public:
-  Callback () {}
+  Callback ()
+  {}
 
   /**
    * Construct a functor call back, supporting operator() calls
@@ -1185,15 +1289,18 @@
    * \internal
    * There are two dummy args below to ensure that this constructor is
    * always properly disambiguated by the c++ compiler.
+   * \tparam FUNCTOR \deduced The actual type of the functor.
    */
   template <typename FUNCTOR>
-  Callback (FUNCTOR const &functor, bool, bool) 
+  Callback (FUNCTOR const &functor, bool, bool)
     : CallbackBase (Create<FunctorCallbackImpl<FUNCTOR,R,T1,T2,T3,T4,T5,T6,T7,T8,T9> > (functor))
   {}
 
   /**
    * Construct a member function pointer call back.
    *
+   * \tparam OBJ_PTR \deduced Type of the target object, as a pointer.
+   * \tparam MEM_PTR \deduced Type of the class member function.
    * \param [in] objPtr Pointer to the object
    * \param [in] memPtr Pointer to the member function
    */
@@ -1214,11 +1321,13 @@
   /**
    * Bind the first arguments
    *
+   * \tparam T \deduced The type of the bound argument.
    * \param [in] a Argument to bind
    * \return The bound callback
    */
   template <typename T>
-  Callback<R,T2,T3,T4,T5,T6,T7,T8,T9> Bind (T a) {
+  Callback<R,T2,T3,T4,T5,T6,T7,T8,T9> Bind (T a)
+  {
     Ptr<CallbackImpl<R,T2,T3,T4,T5,T6,T7,T8,T9,empty> > impl =
       Ptr<CallbackImpl<R,T2,T3,T4,T5,T6,T7,T8,T9,empty> > (
         new BoundFunctorCallbackImpl<
@@ -1230,12 +1339,15 @@
   /**
    * Bind the first two arguments
    *
+   * \tparam TX1 \deduced Type of the first bound argument.
+   * \tparam TX2 \deduced Type of the second bound argument.
    * \param [in] a1 First argument to bind
    * \param [in] a2 Second argument to bind
    * \return The bound callback
    */
   template <typename TX1, typename TX2>
-  Callback<R,T3,T4,T5,T6,T7,T8,T9> TwoBind (TX1 a1, TX2 a2) {
+  Callback<R,T3,T4,T5,T6,T7,T8,T9> TwoBind (TX1 a1, TX2 a2)
+  {
     Ptr<CallbackImpl<R,T3,T4,T5,T6,T7,T8,T9,empty,empty> > impl =
       Ptr<CallbackImpl<R,T3,T4,T5,T6,T7,T8,T9,empty,empty> > (
         new TwoBoundFunctorCallbackImpl<
@@ -1247,13 +1359,17 @@
   /**
    * Bind the first three arguments
    *
+   * \tparam TX1 \deduced The actual type of the first bound argument.
+   * \tparam TX2 \deduced The actual type of the second bound argument.
+   * \tparam TX3 \deduced The actual type of the third bound argument.
    * \param [in] a1 First argument to bind
    * \param [in] a2 Second argument to bind
    * \param [in] a3 Third argument to bind
    * \return The bound callback
    */
   template <typename TX1, typename TX2, typename TX3>
-  Callback<R,T4,T5,T6,T7,T8,T9> ThreeBind (TX1 a1, TX2 a2, TX3 a3) {
+  Callback<R,T4,T5,T6,T7,T8,T9> ThreeBind (TX1 a1, TX2 a2, TX3 a3)
+  {
     Ptr<CallbackImpl<R,T4,T5,T6,T7,T8,T9,empty,empty,empty> > impl =
       Ptr<CallbackImpl<R,T4,T5,T6,T7,T8,T9,empty,empty,empty> > (
         new ThreeBoundFunctorCallbackImpl<
@@ -1267,11 +1383,13 @@
    *
    * \return \c true if I don't have an implementation
    */
-  bool IsNull (void) const {
+  bool IsNull (void) const
+  {
     return (DoPeekImpl () == 0) ? true : false;
   }
   /** Discard the implementation, set it to null */
-  void Nullify (void) {
+  void Nullify (void)
+  {
     m_impl = 0;
   }
 
@@ -1280,14 +1398,16 @@
    * @{
    */
   /** \return Callback value */
-  R operator() (void) const {
+  R operator() (void) const
+  {
     return (*(DoPeekImpl ()))();
   }
   /**
    * \param [in] a1 First argument
    * \return Callback value
    */
-  R operator() (T1 a1) const {
+  R operator() (T1 a1) const
+  {
     return (*(DoPeekImpl ()))(a1);
   }
   /**
@@ -1295,7 +1415,8 @@
    * \param [in] a2 Second argument
    * \return Callback value
    */
-  R operator() (T1 a1, T2 a2) const {
+  R operator() (T1 a1, T2 a2) const
+  {
     return (*(DoPeekImpl ()))(a1,a2);
   }
   /**
@@ -1304,7 +1425,8 @@
    * \param [in] a3 Third argument
    * \return Callback value
    */
-  R operator() (T1 a1, T2 a2, T3 a3) const {
+  R operator() (T1 a1, T2 a2, T3 a3) const
+  {
     return (*(DoPeekImpl ()))(a1,a2,a3);
   }
   /**
@@ -1314,7 +1436,8 @@
    * \param [in] a4 Fourth argument
    * \return Callback value
    */
-  R operator() (T1 a1, T2 a2, T3 a3, T4 a4) const {
+  R operator() (T1 a1, T2 a2, T3 a3, T4 a4) const
+  {
     return (*(DoPeekImpl ()))(a1,a2,a3,a4);
   }
   /**
@@ -1325,7 +1448,8 @@
    * \param [in] a5 Fifth argument
    * \return Callback value
    */
-  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5) const {
+  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5) const
+  {
     return (*(DoPeekImpl ()))(a1,a2,a3,a4,a5);
   }
   /**
@@ -1337,7 +1461,8 @@
    * \param [in] a6 Sixth argument
    * \return Callback value
    */
-  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5,T6 a6) const {
+  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5,T6 a6) const
+  {
     return (*(DoPeekImpl ()))(a1,a2,a3,a4,a5,a6);
   }
   /**
@@ -1350,7 +1475,8 @@
    * \param [in] a7 Seventh argument
    * \return Callback value
    */
-  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5,T6 a6,T7 a7) const {
+  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5,T6 a6,T7 a7) const
+  {
     return (*(DoPeekImpl ()))(a1,a2,a3,a4,a5,a6,a7);
   }
   /**
@@ -1364,7 +1490,8 @@
    * \param [in] a8 Eighth argument
    * \return Callback value
    */
-  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5,T6 a6,T7 a7,T8 a8) const {
+  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5,T6 a6,T7 a7,T8 a8) const
+  {
     return (*(DoPeekImpl ()))(a1,a2,a3,a4,a5,a6,a7,a8);
   }
   /**
@@ -1379,7 +1506,8 @@
    * \param [in] a9 Ninth argument
    * \return Callback value
    */
-  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5,T6 a6,T7 a7,T8 a8, T9 a9) const {
+  R operator() (T1 a1, T2 a2, T3 a3, T4 a4,T5 a5,T6 a6,T7 a7,T8 a8, T9 a9) const
+  {
     return (*(DoPeekImpl ()))(a1,a2,a3,a4,a5,a6,a7,a8,a9);
   }
   /**@}*/
@@ -1390,7 +1518,8 @@
    * \param [in] other Callback
    * \return \c true if we are equal
    */
-  bool IsEqual (const CallbackBase &other) const {
+  bool IsEqual (const CallbackBase &other) const
+  {
     return m_impl->IsEqual (other.GetImpl ());
   }
 
@@ -1400,21 +1529,25 @@
    * \param [in] other Callback Ptr
    * \return \c true if other can be dynamic_cast to my type
    */
-  bool CheckType (const CallbackBase & other) const {
+  bool CheckType (const CallbackBase & other) const
+  {
     return DoCheckType (other.GetImpl ());
   }
   /**
    * Adopt the other's implementation, if type compatible
    *
    * \param [in] other Callback
-   * \returns \c true if \p other was type-compatible and could be adopted.
+   * \returns \c true if \pname{other} was type-compatible and could be adopted.
    */
-  bool Assign (const CallbackBase &other) {
+  bool Assign (const CallbackBase &other)
+  {
     return DoAssign (other.GetImpl ());
   }
+
 private:
   /** \return The pimpl pointer */
-  CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> *DoPeekImpl (void) const {
+  CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> * DoPeekImpl (void) const
+  {
     return static_cast<CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> *> (PeekPointer (m_impl));
   }
   /**
@@ -1423,9 +1556,10 @@
    * \param [in] other Callback Ptr
    * \return \c true if other can be dynamic_cast to my type
    */
-  bool DoCheckType (Ptr<const CallbackImplBase> other) const {
-    if (other != 0 &&
-        dynamic_cast<const CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> *> (PeekPointer (other)) != 0)
+  bool DoCheckType (Ptr<const CallbackImplBase> other) const
+  {
+    if (other != 0
+        && dynamic_cast<const CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> *> (PeekPointer (other)) != 0)
       {
         return true;
       }
@@ -1439,14 +1573,15 @@
       }
   }
   /** \copydoc Assign */
-  bool DoAssign (Ptr<const CallbackImplBase> other) {
+  bool DoAssign (Ptr<const CallbackImplBase> other)
+  {
     if (!DoCheckType (other))
       {
         std::string othTid = other->GetTypeid ();
         std::string myTid = CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9>::DoGetTypeid ();
         NS_FATAL_ERROR_CONT ("Incompatible types. (feed to \"c++filt -t\" if needed)" << std::endl <<
-                        "got=" << othTid << std::endl <<
-                        "expected=" << myTid);
+                             "got=" << othTid << std::endl <<
+                             "expected=" << myTid);
         return false;
       }
     m_impl = const_cast<CallbackImplBase *> (PeekPointer (other));
@@ -1474,272 +1609,163 @@
 }
 
 /**
- * \ingroup makecallbackmemptr
  * @{
  */
 /**
+ * Build Callbacks for class method members which take varying numbers
+ * of arguments and potentially returning a value.
+ *
+ * \tparam T   \deduced Type of the class having the member function.
+ * \tparam OBJ \deduced Type of the class instance.
+ * \tparam R   \deduced Return type of the callback.
+ * \tparam Ts  \deduced Type list of any arguments to the member function.
+ *
  * \param [in] memPtr Class method member pointer
  * \param [in] objPtr Class instance
  * \return A wrapper Callback
- * 
- * Build Callbacks for class method members which take varying numbers of arguments
- * and potentially returning a value.
- */     
-template <typename T, typename OBJ, typename R>
-Callback<R> MakeCallback (R (T::*memPtr)(void), OBJ objPtr) {
-  return Callback<R> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R>
-Callback<R> MakeCallback (R (T::*memPtr)() const, OBJ objPtr) {
-  return Callback<R> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1>
-Callback<R,T1> MakeCallback (R (T::*memPtr)(T1), OBJ objPtr) {
-  return Callback<R,T1> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1>
-Callback<R,T1> MakeCallback (R (T::*memPtr)(T1) const, OBJ objPtr) {
-  return Callback<R,T1> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2>
-Callback<R,T1,T2> MakeCallback (R (T::*memPtr)(T1,T2), OBJ objPtr) {
-  return Callback<R,T1,T2> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2>
-Callback<R,T1,T2> MakeCallback (R (T::*memPtr)(T1,T2) const, OBJ objPtr) {
-  return Callback<R,T1,T2> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1,typename T2, typename T3>
-Callback<R,T1,T2,T3> MakeCallback (R (T::*memPtr)(T1,T2,T3), OBJ objPtr) {
-  return Callback<R,T1,T2,T3> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1,typename T2, typename T3>
-Callback<R,T1,T2,T3> MakeCallback (R (T::*memPtr)(T1,T2,T3) const, OBJ objPtr) {
-  return Callback<R,T1,T2,T3> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4>
-Callback<R,T1,T2,T3,T4> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4), OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4>
-Callback<R,T1,T2,T3,T4> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4) const, OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5>
-Callback<R,T1,T2,T3,T4,T5> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5), OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5>
-Callback<R,T1,T2,T3,T4,T5> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5) const, OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5,typename T6>
-Callback<R,T1,T2,T3,T4,T5,T6> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5,T6), OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5,T6> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5, typename T6>
-Callback<R,T1,T2,T3,T4,T5,T6> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5,T6) const, OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5,T6> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5,typename T6, typename T7>
-Callback<R,T1,T2,T3,T4,T5,T6,T7> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5,T6,T7), OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5, typename T6, typename T7>
-Callback<R,T1,T2,T3,T4,T5,T6,T7> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5,T6,T7) const, OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5,typename T6, typename T7, typename T8>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5,T6,T7,T8), OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5, typename T6, typename T7, typename T8>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5,T6,T7,T8) const, OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5,typename T6, typename T7, typename T8, typename T9>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5,T6,T7,T8,T9), OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> (objPtr, memPtr);
-}
-template <typename T, typename OBJ, typename R, typename T1, typename T2, typename T3, typename T4,typename T5, typename T6, typename T7, typename T8, typename T9>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> MakeCallback (R (T::*memPtr)(T1,T2,T3,T4,T5,T6,T7,T8,T9) const, OBJ objPtr) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> (objPtr, memPtr);
+ *
+ * This \c MakeCallback is invoked with the
+ * method function address first, followed by the \c this pointer:
+ * \code
+ *   MakeCallback ( & MyClass::Handler, this);
+ * \endcode
+ *
+ * There is not a version with bound arguments.  You may be able to
+ * get the same result by using \c MakeBoundCallback with a \c static
+ * member function, as in:
+ * \code
+ *   MakeBoundCallback ( & MyClass::StaticHandler, this);
+ * \endcode
+ * This still leaves two argument slots available for binding.
+ */
+template <typename T, typename OBJ, typename R, typename... Ts>
+Callback<R,Ts...> MakeCallback (R (T::*memPtr)(Ts...), OBJ objPtr)
+{
+  return Callback<R,Ts...> (objPtr, memPtr);
+}
+template <typename T, typename OBJ, typename R, typename... Ts>
+Callback<R,Ts...> MakeCallback (R (T::*memPtr)(Ts...) const, OBJ objPtr)
+{
+  return Callback<R,Ts...> (objPtr, memPtr);
 }
 /**@}*/
 
 /**
- * \ingroup makecallbackfnptr
- * @{
- */
-/**
+ * \ingroup callback
  * \param [in] fnPtr Function pointer
  * \return A wrapper Callback
- * 
+ *
  * Build Callbacks for functions which take varying numbers of arguments
  * and potentially returning a value.
+ *
+ * \tparam R   \deduced Return type of the callback function..
+ * \tparam Ts  \deduced Type list of any arguments to the member function.
  */
-template <typename R>
-Callback<R> MakeCallback (R (*fnPtr)()) {
-  return Callback<R> (fnPtr, true, true);
-}
-template <typename R, typename T1>
-Callback<R,T1> MakeCallback (R (*fnPtr)(T1)) {
-  return Callback<R,T1> (fnPtr, true, true);
-}
-template <typename R, typename T1, typename T2>
-Callback<R,T1,T2> MakeCallback (R (*fnPtr)(T1,T2)) {
-  return Callback<R,T1,T2> (fnPtr, true, true);
-}
-template <typename R, typename T1, typename T2,typename T3>
-Callback<R,T1,T2,T3> MakeCallback (R (*fnPtr)(T1,T2,T3)) {
-  return Callback<R,T1,T2,T3> (fnPtr, true, true);
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4>
-Callback<R,T1,T2,T3,T4> MakeCallback (R (*fnPtr)(T1,T2,T3,T4)) {
-  return Callback<R,T1,T2,T3,T4> (fnPtr, true, true);
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5>
-Callback<R,T1,T2,T3,T4,T5> MakeCallback (R (*fnPtr)(T1,T2,T3,T4,T5)) {
-  return Callback<R,T1,T2,T3,T4,T5> (fnPtr, true, true);
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5,typename T6>
-Callback<R,T1,T2,T3,T4,T5,T6> MakeCallback (R (*fnPtr)(T1,T2,T3,T4,T5,T6)) {
-  return Callback<R,T1,T2,T3,T4,T5,T6> (fnPtr, true, true);
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5,typename T6, typename T7>
-Callback<R,T1,T2,T3,T4,T5,T6,T7> MakeCallback (R (*fnPtr)(T1,T2,T3,T4,T5,T6,T7)) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7> (fnPtr, true, true);
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5,typename T6, typename T7, typename T8>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> MakeCallback (R (*fnPtr)(T1,T2,T3,T4,T5,T6,T7,T8)) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> (fnPtr, true, true);
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5,typename T6, typename T7, typename T8, typename T9>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> MakeCallback (R (*fnPtr)(T1,T2,T3,T4,T5,T6,T7,T8,T9)) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> (fnPtr, true, true);
+template <typename R, typename... Ts>
+Callback<R,Ts...> MakeCallback (R (*fnPtr)(Ts...))
+{
+  return Callback<R,Ts...> (fnPtr, true, true);
 }
-/**@}*/
 
 /**
- * \ingroup makenullcallback
- * @{
- */
-/**
+ * \ingroup callback
  * \return A wrapper Callback
  *
  * Build null Callbacks which take no arguments,
  * for varying number of template arguments,
  * and potentially returning a value.
- */     
-template <typename R>
-Callback<R> MakeNullCallback (void) {
-  return Callback<R> ();
-}
-template <typename R, typename T1>
-Callback<R,T1> MakeNullCallback (void) {
-  return Callback<R,T1> ();
-}
-template <typename R, typename T1, typename T2>
-Callback<R,T1,T2> MakeNullCallback (void) {
-  return Callback<R,T1,T2> ();
-}
-template <typename R, typename T1, typename T2,typename T3>
-Callback<R,T1,T2,T3> MakeNullCallback (void) {
-  return Callback<R,T1,T2,T3> ();
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4>
-Callback<R,T1,T2,T3,T4> MakeNullCallback (void) {
-  return Callback<R,T1,T2,T3,T4> ();
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5>
-Callback<R,T1,T2,T3,T4,T5> MakeNullCallback (void) {
-  return Callback<R,T1,T2,T3,T4,T5> ();
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5,typename T6>
-Callback<R,T1,T2,T3,T4,T5,T6> MakeNullCallback (void) {
-  return Callback<R,T1,T2,T3,T4,T5,T6> ();
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5,typename T6, typename T7>
-Callback<R,T1,T2,T3,T4,T5,T6,T7> MakeNullCallback (void) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7> ();
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5,typename T6, typename T7, typename T8>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> MakeNullCallback (void) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> ();
-}
-template <typename R, typename T1, typename T2,typename T3,typename T4,typename T5,typename T6, typename T7, typename T8, typename T9>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> MakeNullCallback (void) {
-  return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> ();
+ *
+ * \tparam R   \deduced Return type of the callback function..
+ * \tparam Ts  \deduced Type list of any arguments to the member function.
+ */
+template <typename R, typename... Ts>
+Callback<R,Ts...> MakeNullCallback (void)
+{
+  return Callback<R,Ts...> ();
 }
-/**@}*/
 
 
 /**
  * \ingroup makeboundcallback
  * @{
  * Make Callbacks with one bound argument.
+ *
+ * \tparam R   \deduced Return type of the callback
+ * \tparam TX  \deduced Formal type of the first argument to the callback.
+ * \tparam ARG \deduced Actual type of the bound argument.
+ * Remaining template parameters are the types of remaining arguments
+ * to the callback.
  * \param [in] fnPtr Function pointer
  * \param [in] a1 First bound argument
  * \return A bound Callback
- */   
+ */
 template <typename R, typename TX, typename ARG>
-Callback<R> MakeBoundCallback (R (*fnPtr)(TX), ARG a1) {
+Callback<R> MakeBoundCallback (R (*fnPtr)(TX), ARG a1)
+{
   Ptr<CallbackImpl<R,empty,empty,empty,empty,empty,empty,empty,empty,empty> > impl =
-    Create<BoundFunctorCallbackImpl<R (*)(TX),R,TX,empty,empty,empty,empty,empty,empty,empty,empty> >(fnPtr, a1);
+    Create<BoundFunctorCallbackImpl<R (*)(TX),R,TX,empty,empty,empty,empty,empty,empty,empty,empty> > (fnPtr, a1);
   return Callback<R> (impl);
 }
-template <typename R, typename TX, typename ARG, 
+template <typename R, typename TX, typename ARG,
           typename T1>
-Callback<R,T1> MakeBoundCallback (R (*fnPtr)(TX,T1), ARG a1) {
+Callback<R,T1> MakeBoundCallback (R (*fnPtr)(TX,T1), ARG a1)
+{
   Ptr<CallbackImpl<R,T1,empty,empty,empty,empty,empty,empty,empty,empty> > impl =
     Create<BoundFunctorCallbackImpl<R (*)(TX,T1),R,TX,T1,empty,empty,empty,empty,empty,empty,empty> > (fnPtr, a1);
   return Callback<R,T1> (impl);
 }
-template <typename R, typename TX, typename ARG, 
+template <typename R, typename TX, typename ARG,
           typename T1, typename T2>
-Callback<R,T1,T2> MakeBoundCallback (R (*fnPtr)(TX,T1,T2), ARG a1) {
+Callback<R,T1,T2> MakeBoundCallback (R (*fnPtr)(TX,T1,T2), ARG a1)
+{
   Ptr<CallbackImpl<R,T1,T2,empty,empty,empty,empty,empty,empty,empty> > impl =
     Create<BoundFunctorCallbackImpl<R (*)(TX,T1,T2),R,TX,T1,T2,empty,empty,empty,empty,empty,empty> > (fnPtr, a1);
   return Callback<R,T1,T2> (impl);
 }
 template <typename R, typename TX, typename ARG,
           typename T1, typename T2,typename T3>
-Callback<R,T1,T2,T3> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3), ARG a1) {
+Callback<R,T1,T2,T3> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3), ARG a1)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,empty,empty,empty,empty,empty,empty> > impl =
     Create<BoundFunctorCallbackImpl<R (*)(TX,T1,T2,T3),R,TX,T1,T2,T3,empty,empty,empty,empty,empty> > (fnPtr, a1);
   return Callback<R,T1,T2,T3> (impl);
 }
 template <typename R, typename TX, typename ARG,
           typename T1, typename T2,typename T3,typename T4>
-Callback<R,T1,T2,T3,T4> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4), ARG a1) {
+Callback<R,T1,T2,T3,T4> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4), ARG a1)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,empty,empty,empty,empty,empty> > impl =
     Create<BoundFunctorCallbackImpl<R (*)(TX,T1,T2,T3,T4),R,TX,T1,T2,T3,T4,empty,empty,empty,empty> > (fnPtr, a1);
   return Callback<R,T1,T2,T3,T4> (impl);
 }
 template <typename R, typename TX, typename ARG,
           typename T1, typename T2,typename T3,typename T4,typename T5>
-Callback<R,T1,T2,T3,T4,T5> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4,T5), ARG a1) {
+Callback<R,T1,T2,T3,T4,T5> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4,T5), ARG a1)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,empty,empty,empty,empty> > impl =
     Create<BoundFunctorCallbackImpl<R (*)(TX,T1,T2,T3,T4,T5),R,TX,T1,T2,T3,T4,T5,empty,empty,empty> > (fnPtr, a1);
   return Callback<R,T1,T2,T3,T4,T5> (impl);
 }
 template <typename R, typename TX, typename ARG,
           typename T1, typename T2,typename T3,typename T4,typename T5, typename T6>
-Callback<R,T1,T2,T3,T4,T5,T6> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4,T5,T6), ARG a1) {
+Callback<R,T1,T2,T3,T4,T5,T6> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4,T5,T6), ARG a1)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,T6,empty,empty,empty> > impl =
     Create<BoundFunctorCallbackImpl<R (*)(TX,T1,T2,T3,T4,T5,T6),R,TX,T1,T2,T3,T4,T5,T6,empty,empty> > (fnPtr, a1);
   return Callback<R,T1,T2,T3,T4,T5,T6> (impl);
 }
 template <typename R, typename TX, typename ARG,
           typename T1, typename T2,typename T3,typename T4,typename T5, typename T6, typename T7>
-Callback<R,T1,T2,T3,T4,T5,T6,T7> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4,T5,T6,T7), ARG a1) {
+Callback<R,T1,T2,T3,T4,T5,T6,T7> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4,T5,T6,T7), ARG a1)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,empty,empty> > impl =
     Create<BoundFunctorCallbackImpl<R (*)(TX,T1,T2,T3,T4,T5,T6,T7),R,TX,T1,T2,T3,T4,T5,T6,T7,empty> > (fnPtr, a1);
   return Callback<R,T1,T2,T3,T4,T5,T6,T7> (impl);
 }
 template <typename R, typename TX, typename ARG,
           typename T1, typename T2,typename T3,typename T4,typename T5, typename T6, typename T7, typename T8>
-Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4,T5,T6,T7,T8), ARG a1) {
+Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> MakeBoundCallback (R (*fnPtr)(TX,T1,T2,T3,T4,T5,T6,T7,T8), ARG a1)
+{
   Ptr<CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,empty> > impl =
     Create<BoundFunctorCallbackImpl<R (*)(TX,T1,T2,T3,T4,T5,T6,T7,T8),R,TX,T1,T2,T3,T4,T5,T6,T7,T8> > (fnPtr, a1);
   return Callback<R,T1,T2,T3,T4,T5,T6,T7,T8> (impl);
